import 'package:flutter/material.dart';
import 'package:get/get.dart';

import 'package:progamification/src/controllers/leader_board.dart';
import 'package:progamification/src/services/sas_token.service.dart';

class LeaderBoardTable extends StatefulWidget {
  const LeaderBoardTable({super.key});

  @override
  State<LeaderBoardTable> createState() => _LeaderBoardTableState();
}

class _LeaderBoardTableState extends State<LeaderBoardTable> {
  LeaderBoardController leaderBoardController =
      Get.find<LeaderBoardController>();
  SasTokenService sasTokenService = Get.find<SasTokenService>();
  String sasToken = "";

  @override
  initState() {
    super.initState();
    sasTokenService.getSasToken().then((value) {
      setState(() {
        sasToken = value.toString();
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return SizedBox(
        height: 80,
        width: double.infinity,
        child: ListView.builder(
          itemCount: leaderBoardController.leaderBoardData.isNotEmpty
              ? leaderBoardController.leaderBoardData.length
              : 0,
          itemBuilder: (context, i) {
            String userName =
                leaderBoardController.leaderBoardData[i].userName.toString();

            return leaderBoardController.leaderBoardData.isNotEmpty
                ? Container(
                    margin: const EdgeInsets.only(bottom: 2),
                    child: ListTile(
                      tileColor: const Color(0xFFd4e2ff),
                      leading: Padding(
                        padding: const EdgeInsets.symmetric(
                            horizontal: 0, vertical: 0),
                        child: Container(
                          decoration: const BoxDecoration(
                            shape: BoxShape.circle,
                          ),
                          child: const Icon(Icons.account_circle, size: 50),
                        ),
                      ),
                      title: Row(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: [
                            Text(
                              overflow: TextOverflow.ellipsis,
                              maxLines: 1,
                              userName.length >= 15
                                  ? '${userName.substring(0, 13)}...'
                                  : userName,
                              textAlign: TextAlign.left,
                              style: const TextStyle(
                                fontWeight: FontWeight.w600,
                                fontSize: 14,
                              ),
                            ),
                            Text(
                              '${leaderBoardController.leaderBoardData[i].score} points',
                              textAlign: TextAlign.start,
                              style: const TextStyle(
                                fontWeight: FontWeight.w600,
                                fontSize: 14,
                              ),
                            ),
                          ]),
                      trailing: Text(
                        leaderBoardController.leaderBoardData[i].rank
                            .toString(),
                        textAlign: TextAlign.start,
                        style: const TextStyle(
                          fontWeight: FontWeight.w600,
                          fontSize: 14,
                        ),
                      ),
                    ),
                  )
                : const SizedBox(
                    height: 0,
                    width: 0,
                  );
          },
        ));
  }
}
